DECLARE SUB onkb ()
DECLARE SUB offkb ()
DECLARE SUB readassembly ()

'Angelo: Ok here's the documented version of the keyboard interrupt

'Dimension arrays
DIM SHARED kbcontrol%(128), kbmatrix%(128), keyboardonflag%

readassembly          'Read assembly language
onkb                  'Install keyboard interrupt

'demo code
CLS
SCREEN 12
PRINT "Press ESC to end program"
x% = 320
y% = 240
DO
  CIRCLE (x%, y%), 50, 0
  IF kbmatrix%(72) THEN y% = y% - 1
  IF kbmatrix%(77) THEN x% = x% + 1
  IF kbmatrix%(80) THEN y% = y% + 1
  IF kbmatrix%(75) THEN x% = x% - 1
  CIRCLE (x%, y%), 50, 10
LOOP UNTIL kbmatrix%(1) = 1
'end -> demo code

offkb                 'Uninstall keyboard interrupt

'useful scancodes:
'up = 72
'right = 77
'down = 80
'left = 75
'space = 57
'alt = 56
'ctrl = 29
'esc = 1
'+ = 78
'enter = 28
'- = 74
'a = 30
's = 31
'd = 32
'w = 17
'h = 35
'j = 36
'k = 37
'l = 38
'x = 45
'(num)7 = 71
'(num)9 = 73
'(num)5 = 76
'(num)1 = 79
'(num)3 = 81
'g = 34
'z = 44
'c = 46
'end-> useful scancodes

'Keyboard interrupt data
kbisrdata:
DATA &HE9,&H1D,&H00          : '0000   JMP 0020        ;Jump to INSTALL INTERRUPT
DATA &HE9,&H3C,&H00          : '0003   JMP 0042        ;Jump to UNINSTALL INTERRUPT
DATA &H00,&H00               : '0006   ADD [BX+SI],AL  ;\
DATA &H00,&H00               : '0008   ADD [BX+SI],AL  ;  \
DATA &H00,&H00               : '000A   ADD [BX+SI],AL  ;   } Unused space
DATA &H00,&H00               : '000C   ADD [BX+SI],AL  ;  /
DATA &H00,&H00               : '000E   ADD [BX+SI],AL  ;/
DATA &H00,&H00               : '0010   ADD [BX+SI],AL  ;variable: keyboard_matrix_segment
DATA &H00,&H00               : '0012   ADD [BX+SI],AL  ;variable: keyboard_matrix_offset
DATA &H00,&H00               : '0014   ADD [BX+SI],AL  ;variable: dos_isr_handler_offset
DATA &H00,&H00               : '0016   ADD [BX+SI],AL  ;variable: dos_isr_handler_segment
DATA &H00,&H00               : '0018   ADD [BX+SI],AL  ;\
DATA &H00,&H00               : '001A   ADD [BX+SI],AL  ;  \
DATA &H00,&H00               : '001C   ADD [BX+SI],AL  ;  / Unused space
DATA &H00,&H00               : '001E   ADD [BX+SI],AL  ;/
DATA &H1E                    : '0020   PUSH  DS        ;INSTALL INTERRUPT save DS for QBASIC
DATA &H31,&HC0               : '0021   XOR AX,AX       ;\
DATA &H8E,&HD8               : '0023   MOV DS,AX       ; } DS:SI -> interrupt vector 9
DATA &HBE,&H24,&H00          : '0025   MOV SI,0024     ;/
DATA &H0E                    : '0028   PUSH  CS        ;
DATA &H07                    : '0029   POP ES          ;ES = CS
DATA &HBF,&H14,&H00          : '002A   MOV DI,0014     ;ES:DI -> dos_isr_handler_offset
DATA &HFC                    : '002D   CLD             ;Increment SI, DI on string moves
DATA &HA5                    : '002E   MOVSW           ;\
DATA &HA5                    : '002F   MOVSW           ;/ Read address of old handler
DATA &H8C,&HC3               : '0030   MOV BX,ES       ;BX = CS
DATA &H8E,&HC0               : '0032   MOV ES,AX       ;ES = 0
DATA &HBF,&H24,&H00          : '0034   MOV DI,0024     ;ES:DI -> keyboard interrupt vector
DATA &HB8,&H56,&H00          : '0037   MOV AX,0056     ;AX = Offset of new handler from CS
DATA &HFA                    : '003A   CLI             ;Disable interrupts
DATA &HAB                    : '003B   STOSW           ;\
DATA &H89,&HD8               : '003C   MOV AX,BX       ; } Change keyboard interrupt vector
DATA &HAB                    : '003E   STOSW           ;/  to point to new handler
DATA &HFB                    : '003F   STI             ;Enable interrupts
DATA &H1F                    : '0040   POP DS          ;Restore DS for QBASIC
DATA &HCB                    : '0041   RETF            ;
DATA &H1E                    : '0042   PUSH  DS        ;UNINSTALL INTERRUPT save DS for QBASIC
DATA &H31,&HC0               : '0043   XOR AX,AX       ;\
DATA &H8E,&HC0               : '0045   MOV ES,AX       ; } ES:DI -> keyboard interrupt vector
DATA &HBF,&H24,&H00          : '0047   MOV DI,0024     ;/
DATA &HBE,&H14,&H00          : '004A   MOV SI,0014     ;\
DATA &H0E                    : '004D   PUSH  CS        ; } DS:SI -> address of old handler
DATA &H1F                    : '004E   POP DS          ;/
DATA &HFC                    : '004F   CLD             ;Increment SI, DI on string moves
DATA &HFA                    : '0050   CLI             ;Disable interrupts
DATA &HA5                    : '0051   MOVSW           ;\
DATA &HA5                    : '0052   MOVSW           ;/ Change interrupt vector
DATA &HFB                    : '0053   STI             ;Enable interrupts
DATA &H1F                    : '0054   POP DS          ;Restore DS for QBASIC
DATA &HCB                    : '0055   RETF            ;
DATA &HFB                    : '0056   STI             ;INTERRUPT HANDLER enable interrupts
DATA &H9C                    : '0057   PUSHF           ;Save flags
DATA &H50                    : '0058   PUSH  AX        ;Save registers
DATA &H53                    : '0059   PUSH  BX        ;
DATA &H51                    : '005A   PUSH  CX        ;
DATA &H52                    : '005B   PUSH  DX        ;
DATA &H1E                    : '005C   PUSH  DS        ;
DATA &H56                    : '005D   PUSH  SI        ;
DATA &H06                    : '005E   PUSH  ES        ;
DATA &H57                    : '005F   PUSH  DI        ;
DATA &HE4,&H60               : '0060   IN  AL,60       ;AL = Scan code
DATA &HB4,&H01               : '0062   MOV AH,01       ;Assume it's a make code
DATA &HA8,&H80               : '0064   TEST  AL,80     ;
DATA &H74,&H04               : '0066   JZ  006C    ;If it's not a break code then jump
DATA &HB4,&H00               : '0068   MOV AH,00      ;  It's a break code
DATA &H24,&H7F               : '006A   AND AL,7F      ;  key index = code AND 127
DATA &HD0,&HE0               : '006C   SHL AL,1    >;\
DATA &H88,&HC3               : '006E   MOV BL,AL       ; } BX = key index * 2
DATA &HB7,&H00               : '0070   MOV BH,00       ;/
DATA &HB0,&H00               : '0072   MOV AL,00       ;
DATA &H2E                    : '0074   CS:             ;
DATA &H03,&H1E,&H12,&H00     : '0075   ADD BX,[0012]   ;BX = BX + offset of matrix
DATA &H2E                    : '0079   CS:             ;
DATA &H8E,&H1E,&H10,&H00     : '007A   MOV DS,[0010]   ;DS = segment of matrix
DATA &H86,&HE0               : '007E   XCHG  AH,AL     ;
DATA &H89,&H07               : '0080   MOV [BX],AX     ;Store key state
DATA &HE4,&H61               : '0082   IN  AL,61       ;Interrupt Clean up
DATA &H0C,&H82               : '0084   OR  AL,82       ;
DATA &HE6,&H61               : '0086   OUT 61,AL       ;
DATA &H24,&H7F               : '0088   AND AL,7F       ;
DATA &HE6,&H61               : '008A   OUT 61,AL       ;
DATA &HB0,&H20               : '008C   MOV AL,20       ;
DATA &HE6,&H20               : '008E   OUT 20,AL       ;
DATA &H5F                    : '0090   POP DI          ;Restore registers
DATA &H07                    : '0091   POP ES          ;
DATA &H5E                    : '0092   POP SI          ;
DATA &H1F                    : '0093   POP DS          ;
DATA &H5A                    : '0094   POP DX          ;
DATA &H59                    : '0095   POP CX          ;
DATA &H5B                    : '0096   POP BX          ;
DATA &H58                    : '0097   POP AX          ;
DATA &H9D                    : '0098   POPF            ;Restore flags
DATA &HCF                    : '0099   IRET            ;Exit interrupt
DATA -1

SUB offkb
IF (keyboardonflag% = 0) THEN EXIT SUB
keyboardonflag% = 0
DEF SEG = VARSEG(kbcontrol%(0))
CALL ABSOLUTE(3)
DEF SEG
END SUB

SUB onkb
IF keyboardonflag% THEN EXIT SUB
keyboardonflag% = 1
DEF SEG = VARSEG(kbcontrol%(0))
CALL ABSOLUTE(0)
DEF SEG
END SUB

SUB readassembly
RESTORE kbisrdata
DEF SEG = VARSEG(kbcontrol%(0))
i& = 0
GOTO skip0
DO
  POKE i&, q%
  i& = i& + 1
skip0:
  READ q%
LOOP WHILE q% > -1
i& = 16
n& = VARSEG(kbmatrix%(0)): l& = n& AND 255: h& = ((n& AND &HFF00) \ 256): POKE i&, l&: POKE i& + 1, h&: i& = i& + 2
n& = VARPTR(kbmatrix%(0)): l& = n& AND 255: h& = ((n& AND &HFF00) \ 256): POKE i&, l&: POKE i& + 1, h&: i& = i& + 2
DEF SEG
END SUB

