'**********************************************************
'*      keyflags.bas by Kerry S. Goodin, D.D.S.           *
'*        Placed in public domain 11-17-95                *
'*              updated 9/98 for qbasic                   *
'*               use at your own risk                     *
'**********************************************************

' QBasic Code for detecting the status of alt, ctrl, left shift,
' right shift, and insert or the state of the flags of numlock, capslock,
' and scroll lock of ROM BIOS (ie. Flag set on or off)
'
' Shows the use of an assembler program that mimics
' the QuickBasic interrupt SUB in QB quick library.
' Now Qbasic programs can call any interrupt, not just a mouse
' by changing the IntNumber in the SUB InterruptQ.

DECLARE SUB interruptQ (IntNumber AS INTEGER, inRegs AS ANY, outRegs AS ANY)
DECLARE SUB keybFlags ()

DEFINT A-Z

CONST False = 0, True = NOT False




'declare the types of the flags

TYPE Keyboard
 insert AS INTEGER
 CapsLock AS INTEGER
 NumLock  AS INTEGER
 ScrollLock AS INTEGER
 alt AS INTEGER
 Ctrl AS INTEGER
 LeftShift AS INTEGER
 RightShift AS INTEGER
END TYPE


' Define INTERRUPT REGISTERS

TYPE RegType
    ax    AS INTEGER
    bx    AS INTEGER
    cx    AS INTEGER
    dx    AS INTEGER
    bp    AS INTEGER
    si    AS INTEGER
    di    AS INTEGER
    Flags AS INTEGER
    ds    AS INTEGER
    es    AS INTEGER
END TYPE

DIM SHARED inRegs AS RegType
DIM SHARED outRegs AS RegType
DIM SHARED kb AS Keyboard
REDIM SHARED Assembler(1 TO 50)


' Places Assembler Program into Memory

DEF SEG = VARSEG(Assembler(1))
Address = VARPTR(Assembler(1))
FOR I = 0 TO 99
        READ a
        POKE Address + I, a
NEXT I


CLS
PRINT "Demo of reading the keyboard flags"
PRINT "press esc to end"

DO
 COLOR 4, 7, 0
 LOCATE 20, 5, 0:
 CALL keybFlags
 IF kb.alt THEN
     PRINT " alt ";
 ELSE
     PRINT "     ";
 END IF
 IF kb.Ctrl THEN
     PRINT " Ctrl ";
 ELSE
     PRINT "      ";
 END IF
 IF kb.LeftShift THEN
     PRINT " LeftShift ";
 ELSE
     PRINT "           ";
 END IF
 IF kb.RightShift THEN
     PRINT " RightShift ";
 ELSE
     PRINT "            ";
 END IF
 IF kb.insert THEN
     PRINT " Insert ";
 ELSE
     PRINT "        ";
 END IF
 IF kb.CapsLock THEN
     PRINT " CapsLock ";
 ELSE
     PRINT "          ";
 END IF
 IF kb.NumLock THEN
     PRINT " NumLock ";
 ELSE
     PRINT "         ";
 END IF
 IF kb.ScrollLock THEN
     PRINT " ScrollLock ";
 ELSE
     PRINT "            ";
 END IF
 IF INKEY$ = CHR$(27) THEN EXIT DO 'get out of loop

LOOP

END


'Data for the Assembler Program

DATA 85,139,236,86,87,30,139,118,6,139,4,139,92,2,139,76,4,139,84,6,139
DATA 108,8,139,124,12,142,68,18,255,116,10,131,124,18,255,117,2,30,7
DATA 131,124,16,255,116,3,142,92,16,94,205,33,85,139,236,30,86,142,94,2
DATA 139,118,14,137,4,137,92,2,137,76,4,137,84,6,143,68,10,143,68,16
DATA 143,68,8,137,124,12,140,68,18,156,143,68,14,95,95,94,93,202,2,0


' ************************************
' * Calls an interrupt from the call *
' * absolute array read into memory  *
' ************************************
'
SUB interruptQ (IntNumber AS INTEGER, inRegs AS RegType, outRegs AS RegType)

  'keep the value of inReg
  outRegs = inRegs

  DEF SEG = VARSEG(Assembler(1))
  Address = VARPTR(Assembler(1))
  POKE Address + 51, IntNumber

  CALL ABSOLUTE(outRegs, Address)

END SUB

SUB keybFlags

 'call the keyboard flags service
        'Int 16H Function 02H

 inRegs.ax = &H200
 CALL interruptQ(&H16, inRegs, outRegs)

 'extract the bits of the flag byte
 kb.insert = outRegs.ax \ 128
 kb.CapsLock = (outRegs.ax AND &H40) \ 64
 kb.NumLock = (outRegs.ax AND &H20) \ 32
 kb.ScrollLock = (outRegs.ax AND &H10) \ 16
 kb.alt = (outRegs.ax AND &H8) \ 8
 kb.Ctrl = (outRegs.ax AND &H4) \ 4
 kb.LeftShift = (outRegs.ax AND &H2) \ 2
 kb.RightShift = (outRegs.ax AND 1)

END SUB

