'
'  **************************************************
'  *                                                *
'  *                  LISTFILE.BAS                  *
'  *                                                *
'  *     List ASCII file with sequence numbers      *
'  *                                                *
'  *              Judson D. McClendon               *
'  *              Sun Valley Systems                *
'  *              4522 Shadow Ridge Pkwy            *
'  *              Pinson, AL 35126-2192             *
'  *                 205-680-0460                   *
'  *                                                *
'  **************************************************
'
CONST LineWidth = 80, TabSkip = 8, ShortWidth = LineWidth - TabSkip + 1
CONST LinesPage = 58

DIM FileName AS STRING, Header AS STRING
DIM LineCount AS INTEGER, PageCount AS INTEGER, RecordCount AS LONG

FileName = COMMAND$
IF (FileName = "") THEN
   INPUT "Enter file name (RETURN to exit): ", FileName
ELSE
   PRINT "File "; FileName
END IF

Header = LEFT$(UCASE$(FileName) + SPACE$(50), 50)
Header = Header + SPACE$(LineWidth - LEN(Header) - 26)
Header = Header + DATE$ + " " + LEFT$(TIME$, 5) + "  Page ###"

OPEN "I", #1, FileName
OPEN "O", #2, "PRN"

LineCount = 99: PageCount = 0: RecordCount = 0

'
' Read Loop
'
WHILE (NOT (EOF(1) OR INKEY$ = CHR$(27)))
   LINE INPUT #1, R$
   RecordCount = RecordCount + 1

   IF (LineCount > LinesPage) THEN
      GOSUB PageHeading
   END IF
   PRINT #2, USING "#####:"; RecordCount;
   WHILE (LEN(R$) > ShortWidth)
      IF (LineCount > LinesPage) THEN
         GOSUB PageHeading
      END IF
      PRINT #2, TAB(TabSkip); LEFT$(R$, ShortWidth)
      LineCount = LineCount + 1
      R$ = MID$(R$, ShortWidth + 1)
   WEND

   IF (LineCount > LinesPage) THEN
      GOSUB PageHeading
   END IF
   PRINT #2, TAB(TabSkip); R$
   LineCount = LineCount + 1
WEND

'
' End Program
'
PRINT #2, CHR$(12);
CLOSE 1, 2
END


PageHeading:

   IF (LineCount < 99) THEN
      PRINT #2, CHR$(12);
   END IF
   PageCount = PageCount + 1

   PRINT #2, USING Header; PageCount
   PRINT #2, ""
   LineCount = 2
   RETURN
