'All-purpose Joystick routines
'Source Code by Dmitry Brant (d.brant64@csuohio.edu)
'Please give credit where credit is due.
'Sorry about the lack of documentation, but I'm just not the
'documenting type... All these functions should be self-
'explanatory. If you think they're not, email me.
'
'These functions are provided 'AS-IS'. I can't be held
'responsible for any damage, physical or phychological, caused
'by the use or misuse of this source code. Thanks!

DEFINT A-Z                          'For faster program speed
'$INCLUDE: 'qb.bi'                  'Interrupt Definitions by QuickBasic
		   'JOYSTICK FUNCTIONS
DECLARE SUB ClearJ ()                    'Clear joystick button buffer
DECLARE FUNCTION JoyButtons% ()          'See which buttons are pressed
DECLARE FUNCTION JoyX% ()                'Get X coordinate
DECLARE FUNCTION JoyY% ()                'Get Y coordinate
DECLARE FUNCTION JoyThrottle% ()         'Get throttle value
COMMON SHARED inregs AS RegType
COMMON SHARED outregs AS RegType

'Demo
SCREEN 13: CLS
PRINT "Joystick Demo by Dmitry Brant"
LOCATE 10, 10: PRINT "Coordinates: "
LOCATE 12, 10: PRINT "Buttons: "
LOCATE 14, 10: PRINT "Throttle: "

DO UNTIL INKEY$ <> ""
	LOCATE 10, 23: PRINT JoyX; JoyY; "   "
	LOCATE 12, 19
	b = JoyButtons AND &HF0
	IF NOT b AND &H10 THEN PRINT "1";
	IF NOT b AND &H20 THEN PRINT " 2";
	IF NOT b AND &H40 THEN PRINT " 3";
	IF NOT b AND &H80 THEN PRINT " 4";
	PRINT "          "
	LOCATE 14, 20: PRINT JoyThrottle%
LOOP
SYSTEM

SUB ClearJ
Repeat:
IF STRIG(0) OR STRIG(1) OR STRIG(2) OR STRIG(3) OR STRIG(4) OR STRIG(5) THEN GOTO Repeat
END SUB

FUNCTION JoyButtons
JoyButtons = INP(&H200)
END FUNCTION

FUNCTION JoyThrottle
inregs.ax = &H8400
inregs.dx = 1
CALL Interrupt(&H15, inregs, outregs)
JoyThrottle = outregs.dx
END FUNCTION

FUNCTION JoyX
inregs.ax = &H8400
inregs.dx = 1
CALL Interrupt(&H15, inregs, outregs)
JoyX = outregs.ax
END FUNCTION

FUNCTION JoyY
inregs.ax = &H8400
inregs.dx = 1
CALL Interrupt(&H15, inregs, outregs)
JoyY = outregs.bx
END FUNCTION

